//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Gold
#property indicator_color2  DeepSkyBlue
#property indicator_minimum 0
#property indicator_maximum 100

extern int Stoch1KPeriod   =  300;
extern int Stoch1Slowing   =    3;
extern int Stoch1Price     =    0;
extern int Stoch2KPeriod   =  600;
extern int Stoch2Slowing   =    3;
extern int Stoch2Price     =    0;
extern int NormalizeDigits = 5;

extern bool   verticalLinesVisible   = true;
extern string verticalLinesID        = "StochLines";
extern color  verticalLinesInColor   = Gold;
extern color  verticalLinesOutColor  = DeepSkyBlue;
extern int    verticalLinesStyle     = STYLE_DOT;
extern int    verticalLinesWidth     = 0;

//
//
//
//
//

double stoch1[];
double stoch2[];
double equal[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
    SetIndexBuffer(0,stoch1);
    SetIndexBuffer(1,stoch2);
    SetIndexBuffer(2,equal);
    return(0);
}
int deinit()
{
   string lookFor       = verticalLinesID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i = limit; i >=0; i--)
   {
      stoch1[i] = NormalizeDouble(iStochastic(NULL,0,Stoch1KPeriod,1,Stoch1Slowing,MODE_SMA,Stoch1Price,MODE_MAIN,i),NormalizeDigits);
      stoch2[i] = NormalizeDouble(iStochastic(NULL,0,Stoch2KPeriod,1,Stoch2Slowing,MODE_SMA,Stoch2Price,MODE_MAIN,i),NormalizeDigits);
      equal[i]  = 0;
         ObjectDelete(verticalLinesID+":"+Time[i]);
         if (stoch1[i]==stoch2[i]) equal[i]=1;
         if (equal[i] != equal[i+1])
               if (equal[i] == 1)
                     drawLine(i,verticalLinesInColor);
               else  drawLine(i,verticalLinesOutColor);
   }
   return(0);
}

//
//
//
//
//

void drawLine(int i,color theColor)
{
   string name = verticalLinesID+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

